<template>
  <v-row>
    <v-col v-for="day in trainingDays" :key="day">
      <v-card color="accent">
        <v-card-title>{{ dayLabel(day) }}</v-card-title>

        <v-list :expand="true">
          <v-list-group
            v-for="room in roomsOfDay(day)"
            :key="room"
            :value="true"
          >
            <template v-slot:activator>
              <v-list-item-content>
                <v-list-item-title>
                  {{ room }}
                </v-list-item-title>
              </v-list-item-content>
            </template>
            <training-button
              v-for="(training, idx) in trainingsOfDayAndRoom(day, room)"
              :key="idx"
              :training="training"
              :position="classement(training)"
              :value="isSelected(training)"
              :disabled="!isSelected(training) && value.length == max"
              :read-only="!max"
              @input="toggleTraining(training)"
            />
          </v-list-group>
        </v-list>
      </v-card>
    </v-col>
  </v-row>
</template>

<script>
import { isEqual, findIndex } from 'lodash'
import TrainingButton from './TrainingButton.vue'

export default {
  components: {
    TrainingButton,
  },

  props: {
    trainings: {
      type: Array,
      required: true,
    },
    max: {
      type: Number,
      default: 0,
    },
    value: {
      type: Array,
      default: () => [],
    },
  },

  data: () => ({
    days: [
      'monday',
      'tuesday',
      'wednesday',
      'thursday',
      'friday',
      'saturday',
      'sunday',
    ],
    dayLabels: [
      'Lundi',
      'Mardi',
      'Mercredi',
      'Jeudi',
      'Vendredi',
      'Samedi',
      'Dimanche',
    ],
  }),

  computed: {
    trainingDays() {
      return this.days.filter((day) => this.trainingsOfDay(day).length)
    },
  },

  methods: {
    dayLabel(day) {
      return this.dayLabels[this.days.indexOf(day)]
    },
    trainingsOfDay(day) {
      return this.trainings.filter((training) => training.day === day)
    },
    roomsOfDay(day) {
      return [
        ...new Set(this.trainingsOfDay(day).map((training) => training.room)),
      ]
    },
    trainingsOfDayAndRoom(day, room) {
      return this.trainingsOfDay(day).filter(
        (training) => training.room === room
      )
    },
    index(training) {
      return findIndex(this.value, (val) => isEqual(val, training))
    },
    classement(training) {
      return this.index(training) + 1
    },
    isSelected(training) {
      return this.classement(training) !== 0
    },
    toggleTraining(training) {
      const index = this.index(training)
      const valueCopy = this.value.slice()
      if (index === -1) {
        if (valueCopy.length < this.max) {
          valueCopy.push(training)
        }
      } else {
        valueCopy.splice(index, 1)
      }
      this.$emit('input', valueCopy)
    },
  },
}
</script>
